<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>scripts.multiple_candidates.scripts_select.a_select_multiple_candidates package &mdash; RDstar_light  documentation</title>
      <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
      <link rel="stylesheet" href="_static/css/theme.css" type="text/css" />
  <!--[if lt IE 9]>
    <script src="_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script data-url_root="./" id="documentation_options" src="_static/documentation_options.js"></script>
        <script src="_static/jquery.js"></script>
        <script src="_static/underscore.js"></script>
        <script src="_static/_sphinx_javascript_frameworks_compat.js"></script>
        <script src="_static/doctools.js"></script>
    <script src="_static/js/theme.js"></script>
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <link rel="next" title="scripts.multiple_candidates.scripts_select.b_compare_fit_results package" href="scripts.multiple_candidates.scripts_select.b_compare_fit_results.html" />
    <link rel="prev" title="scripts.multiple_candidates.scripts_select package" href="scripts.multiple_candidates.scripts_select.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
            <a href="index.html" class="icon icon-home"> RDstar_light
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <ul class="current">
<li class="toctree-l1"><a class="reference internal" href="lib.html">lib package</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="scripts.html">scripts.multiple_candidates package</a><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="scripts.html#multiple-candidates">Multiple candidates</a></li>
<li class="toctree-l2"><a class="reference internal" href="scripts.html#subpackages">Subpackages</a></li>
<li class="toctree-l2 current"><a class="reference internal" href="scripts.html#scripts">Scripts</a><ul class="current">
<li class="toctree-l3"><a class="reference internal" href="scripts.multiple_candidates.scripts_ana.html">scripts.multiple_candidates.scripts_ana package</a></li>
<li class="toctree-l3 current"><a class="reference internal" href="scripts.multiple_candidates.scripts_select.html">scripts.multiple_candidates.scripts_select package</a><ul class="current">
<li class="toctree-l4 current"><a class="current reference internal" href="#">scripts.multiple_candidates.scripts_select.a_select_multiple_candidates package</a></li>
<li class="toctree-l4"><a class="reference internal" href="scripts.multiple_candidates.scripts_select.b_compare_fit_results.html">scripts.multiple_candidates.scripts_select.b_compare_fit_results package</a></li>
<li class="toctree-l4"><a class="reference internal" href="scripts.multiple_candidates.scripts_select.c_compute_chi2.html">scripts.multiple_candidates.scripts_select.c_compute_chi2 package</a></li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="index.html">RDstar_light</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="index.html" class="icon icon-home"></a> &raquo;</li>
          <li><a href="scripts.html">scripts.multiple_candidates package</a> &raquo;</li>
          <li><a href="scripts.multiple_candidates.scripts_select.html">scripts.multiple_candidates.scripts_select package</a> &raquo;</li>
      <li>scripts.multiple_candidates.scripts_select.a_select_multiple_candidates package</li>
      <li class="wy-breadcrumbs-aside">
            <a href="_sources/scripts.multiple_candidates.scripts_select.a_select_multiple_candidates.rst.txt" rel="nofollow"> View page source</a>
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <div class="section" id="scripts-multiple-candidates-scripts-select-a-select-multiple-candidates-package">
<h1>scripts.multiple_candidates.scripts_select.a_select_multiple_candidates package<a class="headerlink" href="#scripts-multiple-candidates-scripts-select-a-select-multiple-candidates-package" title="Permalink to this heading"></a></h1>
<div class="section" id="module-scripts.multiple_candidates.scripts_select.a_select_multiple_candidates.config">
<span id="scripts-multiple-candidates-scripts-select-a-select-multiple-candidates-config-module"></span><h2>scripts.multiple_candidates.scripts_select.a_select_multiple_candidates.config module<a class="headerlink" href="#module-scripts.multiple_candidates.scripts_select.a_select_multiple_candidates.config" title="Permalink to this heading"></a></h2>
<p>Configuration of the scripts
<code class="xref py py-mod docutils literal notranslate"><span class="pre">multiple_candidates.scripts_select.a_select_multiple_candidates.run</span></code></p>
<dl class="py data">
<dt class="sig sig-object py" id="scripts.multiple_candidates.scripts_select.a_select_multiple_candidates.config.list_loaded_columns">
<span class="sig-prename descclassname"><span class="pre">scripts.multiple_candidates.scripts_select.a_select_multiple_candidates.config.</span></span><span class="sig-name descname"><span class="pre">list_loaded_columns</span></span><em class="property"><span class="w"> </span><span class="p"><span class="pre">=</span></span><span class="w"> </span><span class="pre">None</span></em><a class="headerlink" href="#scripts.multiple_candidates.scripts_select.a_select_multiple_candidates.config.list_loaded_columns" title="Permalink to this definition"></a></dt>
<dd><p>List of the columns to load and save</p>
</dd></dl>

</div>
<div class="section" id="module-scripts.multiple_candidates.scripts_select.a_select_multiple_candidates.run">
<span id="scripts-multiple-candidates-scripts-select-a-select-multiple-candidates-run-script"></span><h2>scripts.multiple_candidates.scripts_select.a_select_multiple_candidates.run script<a class="headerlink" href="#module-scripts.multiple_candidates.scripts_select.a_select_multiple_candidates.run" title="Permalink to this heading"></a></h2>
<p>Find and apply different requirements on multiple candidates
in a given ROOT file.</p>
<p>To remove all the multiple candidates from a ROOT sample, run</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">python</span> <span class="o">./</span><span class="n">scripts_selct</span><span class="o">/</span><span class="n">a_select_multiple_candidates</span><span class="o">/</span><span class="n">run</span><span class="o">.</span><span class="n">py</span>         <span class="o">-</span><span class="n">i</span> <span class="p">{</span><span class="n">inpath</span><span class="p">}</span> <span class="o">-</span><span class="n">o</span> <span class="p">{</span><span class="n">outpath</span><span class="p">}</span> <span class="o">-</span><span class="n">t</span> <span class="p">{</span><span class="n">tree_name</span><span class="p">}</span> <span class="o">-</span><span class="n">muc_strat</span> <span class="n">sc</span>
</pre></div>
</div>
<p>where <code class="docutils literal notranslate"><span class="pre">sc</span></code> stands for single candidates. <code class="docutils literal notranslate"><span class="pre">inpath</span></code> and <code class="docutils literal notranslate"><span class="pre">outpath</span></code> are
the path of the input and output ROOT files, opened and saved using uproot.
<code class="docutils literal notranslate"><span class="pre">{tree_name}</span></code> is the common name of the input and output ROOT files.</p>
<p>To only keep one multiple candidate for every multiple event, as it is
a random choice, you need to choose a random seed <code class="docutils literal notranslate"><span class="pre">{seed}</span></code>.
(an integer, e.g., 20)</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">python</span> <span class="o">./</span><span class="n">scripts_selct</span><span class="o">/</span><span class="n">a_select_multiple_candidates</span><span class="o">/</span><span class="n">run</span><span class="o">.</span><span class="n">py</span> <span class="o">-</span><span class="n">i</span> <span class="p">{</span><span class="n">inpath</span><span class="p">}</span>
<span class="o">-</span><span class="n">o</span> <span class="p">{</span><span class="n">outpath</span><span class="p">}</span> <span class="o">-</span><span class="n">t</span> <span class="p">{{</span><span class="n">tree_name</span><span class="p">}</span> <span class="o">-</span><span class="n">muc_strat</span> <span class="n">random</span> <span class="o">--</span><span class="n">seed</span> <span class="p">{</span><span class="n">seed</span><span class="p">}</span>
</pre></div>
</div>
<p>Finally, the multiple candidate can be chosen as the one that minimises
or maximises some column:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">python</span> <span class="o">./</span><span class="n">scripts_selct</span><span class="o">/</span><span class="n">a_select_multiple_candidates</span><span class="o">/</span><span class="n">run</span><span class="o">.</span><span class="n">py</span>     <span class="o">-</span><span class="n">i</span> <span class="p">{</span><span class="n">inpath</span><span class="p">}</span> <span class="o">-</span><span class="n">o</span> <span class="p">{</span><span class="n">outpath</span><span class="p">}</span> <span class="o">-</span><span class="n">t</span> <span class="p">{</span><span class="n">tree_name</span><span class="p">}</span>     <span class="o">-</span><span class="n">muc_strat</span> <span class="n">opt</span> <span class="o">-</span><span class="n">c</span> <span class="p">{</span><span class="n">opt_column</span><span class="p">}</span> <span class="o">-</span><span class="n">b</span> <span class="p">{</span><span class="n">opt_best</span><span class="p">}</span>
</pre></div>
</div>
<p>where <code class="docutils literal notranslate"><span class="pre">{opt_column}</span></code> is the the column whose value is larger or lower
according to the quality or signal-likeness of the candidate, and
<code class="docutils literal notranslate"><span class="pre">opt_best</span></code> is <code class="docutils literal notranslate"><span class="pre">max</span></code> or <code class="docutils literal notranslate"><span class="pre">min</span></code> according to whether <code class="docutils literal notranslate"><span class="pre">{opt_column}</span></code> must
be minimised or maximised.</p>
<p>Note that if <code class="docutils literal notranslate"><span class="pre">{outpath}</span></code> is not provided, it is automatically determined
from the {inpath}.</p>
<dl class="py function">
<dt class="sig sig-object py" id="scripts.multiple_candidates.scripts_select.a_select_multiple_candidates.run.get_seed">
<span class="sig-prename descclassname"><span class="pre">scripts.multiple_candidates.scripts_select.a_select_multiple_candidates.run.</span></span><span class="sig-name descname"><span class="pre">get_seed</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">base_seed</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">hash_key</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/scripts/multiple_candidates/scripts_select/a_select_multiple_candidates/run.html#get_seed"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#scripts.multiple_candidates.scripts_select.a_select_multiple_candidates.run.get_seed" title="Permalink to this definition"></a></dt>
<dd><p>Get a <code class="docutils literal notranslate"><span class="pre">seed</span></code> from a <code class="docutils literal notranslate"><span class="pre">base_seed</span></code> and a string.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>base_seed</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">int</span></code>) – common seed</p></li>
<li><p><strong>hash_key</strong> (<code class="xref py py-class docutils literal notranslate"><span class="pre">str</span></code>) – a string</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>random seed</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p>seed</p>
</dd>
</dl>
<p class="rubric">Notes</p>
<p>It allows to get a different seed for each file, parametrised by
a key, in order to have a different seed for each sample,
but everytime the same.</p>
<p>The result is the result of the hashing of <cite>hash_key</cite> with the
key <cite>base_seed</cite></p>
</dd></dl>

</div>
</div>


           </div>
          </div>
          <footer><div class="rst-footer-buttons" role="navigation" aria-label="Footer">
        <a href="scripts.multiple_candidates.scripts_select.html" class="btn btn-neutral float-left" title="scripts.multiple_candidates.scripts_select package" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left" aria-hidden="true"></span> Previous</a>
        <a href="scripts.multiple_candidates.scripts_select.b_compare_fit_results.html" class="btn btn-neutral float-right" title="scripts.multiple_candidates.scripts_select.b_compare_fit_results package" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right" aria-hidden="true"></span></a>
    </div>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright .</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>